Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class IndexSearcher

    java.lang.Object
      org.apache.lucene.search.Searcher
          org.apache.lucene.search.IndexSearcher

All Implemented Interfaces:
  Remote, Searchable

    public class IndexSearcher

extends Searcher

Implements search over a single IndexReader.

Applications usually need only call the inherited `Searcher.search(Query)` or `Searcher.search(Query,Filter)` methods. For performance reasons it is recommended to open only one IndexSearcher and use it for all of your searches.

Note that you can only access Hits from an IndexSearcher as long as it is not yet closed, otherwise an IOException will be thrown.

Constructor Summary
`IndexSearcher(Directory directory)` Creates a searcher searching the index in the provided directory.
`IndexSearcher(IndexReader r)` Creates a searcher searching the provided index.
`IndexSearcher(String path)` Creates a searcher searching the index in the named directory.

Method Summary
`void` | `close()` Note that the underlying IndexReader is not closed, if IndexSearcher was constructed with IndexSearcher(IndexReader r).
`Document` | `doc(int i)` Expert: Returns the stored fields of document `i`.
`Document` | `doc(int i, FieldSelector fieldSelector)` Get the `Document` at the `n`th position.
`int` | `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
`Explanation` | `explain(Weight weight, int doc)` Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.
`IndexReader` | `getIndexReader()` Return the `IndexReader` this searches.
`int` | `maxDoc()` Expert: Returns one greater than the largest possible document number.
`Query` | `rewrite(Query original)` Expert: called to re-write queries into primitive queries.
`void` | `search(Weight weight, Filter filter, HitCollector results)` Lower-level search API.
`TopDocs` | `search(Weight weight, Filter filter, int nDocs)` Expert: Low-level search implementation.
`TopFieldDocs` | `search(Weight weight, Filter filter, int nDocs, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.

Methods inherited from class org.apache.lucene.search.Searcher
`createWeight, docFreqs, explain, getSimilarity, search, search, search, search, search, search, search, search, search, setSimilarity`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### IndexSearcher

    public IndexSearcher(String path)
                  throws CorruptIndexException,
                         IOException

  Creates a searcher searching the index in the named directory.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### IndexSearcher

    public IndexSearcher(Directory directory)
                  throws CorruptIndexException,
                         IOException

  Creates a searcher searching the index in the provided directory.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### IndexSearcher

    public IndexSearcher(IndexReader r)

  Creates a searcher searching the provided index.

Method Detail

### getIndexReader

    public IndexReader getIndexReader()

  Return the `IndexReader` this searches.

### close

    public void close()
               throws IOException

  Note that the underlying IndexReader is not closed, if IndexSearcher was constructed with IndexSearcher(IndexReader r). If the IndexReader was supplied implicitly by specifying a directory, then the IndexReader gets closed.

  Specified by:
    `close` in interface `Searchable`
  Specified by:
    `close` in class `Searcher`
  Throws:
    `IOException`

### docFreq

    public int docFreq(Term term)
                throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns the number of documents containing `term`. Called by search code to compute term weights.

  Specified by:
    `docFreq` in interface `Searchable`
  Specified by:
    `docFreq` in class `Searcher`
  Throws:
    `IOException`
  See Also:
    `IndexReader.docFreq(Term)`

### doc

    public Document doc(int i)
                 throws CorruptIndexException,
                        IOException

  Description copied from interface: `Searchable`
  Expert: Returns the stored fields of document `i`. Called by `HitCollector` implementations.

  Specified by:
    `doc` in interface `Searchable`
  Specified by:
    `doc` in class `Searcher`
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `IndexReader.document(int)`

### doc

    public Document doc(int i,
                        FieldSelector fieldSelector)
                 throws CorruptIndexException,
                        IOException

  Description copied from interface: `Searchable`
  Get the `Document` at the `n`th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If the underlying Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

  Parameters:
    `i` - Get the document at the `n`th position
    `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
  Returns:
    The stored fields of the `Document` at the nth position
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `IndexReader.document(int, FieldSelector)`, `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

### maxDoc

    public int maxDoc()
               throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns one greater than the largest possible document number. Called by search code to compute term weights.

  Specified by:
    `maxDoc` in interface `Searchable`
  Specified by:
    `maxDoc` in class `Searcher`
  Throws:
    `IOException`
  See Also:
    `IndexReader.maxDoc()`

### search

    public TopDocs search(Weight weight,
                          Filter filter,
                          int nDocs)
                   throws IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

  Called by `Hits`.

  Applications should usually call `Searcher.search(Query)` or `Searcher.search(Query,Filter)` instead.

  Specified by:
    `search` in interface `Searchable`
  Specified by:
    `search` in class `Searcher`
  Throws:
    `IOException`

### search

    public TopFieldDocs search(Weight weight,
                               Filter filter,
                               int nDocs,
                               Sort sort)
                        throws IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  Applications should usually call `Searcher.search(Query,Filter,Sort)` instead.

  Specified by:
    `search` in interface `Searchable`
  Specified by:
    `search` in class `Searcher`
  Throws:
    `IOException`

### search

    public void search(Weight weight,
                       Filter filter,
                       HitCollector results)
                throws IOException

  Description copied from interface: `Searchable`
  Lower-level search API.

  `HitCollector.collect(int,float)` is called for every non-zero scoring document.
  HitCollector-based access to remote indexes is discouraged.

  Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

  Specified by:
    `search` in interface `Searchable`
  Specified by:
    `search` in class `Searcher`
  Parameters:
    `weight` - to match documents
    `filter` - if non-null, used to permit documents to be collected.
    `results` - to receive hits
  Throws:
    `IOException`

### rewrite

    public Query rewrite(Query original)
                  throws IOException

  Description copied from interface: `Searchable`
  Expert: called to re-write queries into primitive queries.

  Specified by:
    `rewrite` in interface `Searchable`
  Specified by:
    `rewrite` in class `Searcher`
  Throws:
    `IOException`

### explain

    public Explanation explain(Weight weight,
                               int doc)
                        throws IOException

  Description copied from interface: `Searchable`
  Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Applications should call `Searcher.explain(Query, int)`.

  Specified by:
    `explain` in interface `Searchable`
  Specified by:
    `explain` in class `Searcher`
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.